/*    Copyright (C) 2003 Dave Ackley                         (-*- C++ -*-)

      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.

      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef WORLD_H
#define WORLD_H

// Ackley for CS591 F'2003

#include <vector>
#include <iostream>

class Object;                   // Forward

class World {
public:
  World() ;
  ~World() ;

  void Resize(size_t w, size_t h) ;

  enum Direction { CENTER, NORTH, SOUTH, EAST, WEST } ;
  void GetXY(size_t & x, size_t &y, size_t dir = CENTER) ;

  Object * Get(size_t x, size_t y) const ;

  void Put(size_t x, size_t y, Object *) ;

  void Dump(ostream &) const; 

  void AddMass(size_t amt) { _mass += amt; }
  void RemoveMass(size_t amt) {
    assert(_mass >= amt);
    _mass -= amt;
  }
  unsigned long long GetMass() const { return _mass; }

private:
  void _Flush() ;
  void _Wrap(size_t & x, size_t & y, Direction dir) ;

  unsigned long long _mass;
  
  size_t _counts[3];

  size_t _width;
  size_t _height;

  typedef vector< Object * > _vO;
  typedef vector<_vO> _vvO;
  _vvO _map;
} ;

#endif
